<?php
/*
Title: ogcws.php

Funes utilizadas pelo editor do arquivo ogcws.map

Licenca:

GPL2

i3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Ministrio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@mma.gov.br

Este programa  software livre; voc pode redistribu-lo
e/ou modific-lo sob os termos da Licena Pblica Geral
GNU conforme publicada pela Free Software Foundation;

Este programa  distribudo na expectativa de que seja til,
porm, SEM NENHUMA GARANTIA; nem mesmo a garantia implcita
de COMERCIABILIDADE OU ADEQUAO A UMA FINALIDADE ESPECFICA.
Consulte a Licena Pblica Geral do GNU para mais detalhes.
Voc deve ter recebido uma cpia da Licena Pblica Geral do
GNU junto com este programa; se no, escreva para a
Free Software Foundation, Inc., no endereo
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

Arquivo:

i3geo/admin/php/ogcws.php

Parametros:

O parmetro principal  "funcao", que define qual operao ser executada, por exemplo, ms_configura.php?funcao=PEGAPARAMETROSCONFIGURA

Cada operao possu seus prprios parmetros, que devem ser enviados tambm na requisio da operao.

*/
include_once("admin.php");
if(verificaEditores($editores) == "nao")
{echo "Vc nao e um editor cadastrado. Apenas os editores definidos em i3geo/ms_configura.php podem acessar o sistema de administracao.";exit;}
//error_reporting(E_ALL);
$versao = versao();
$map_file = $locaplic."/aplicmap/ogcwsv".$versao["principal"].".map";

$mapa = ms_newMapObj($map_file);
$web = $mapa->web;
//faz a busca da funo que deve ser executada
switch (strtoupper($funcao))
{
	/*
	Note:
	
	Valores que o parmetro &funcao pode receber. Os parmetros devem ser enviados na requisio em AJAX.
	*/
	/*
	Valor: PEGAPARAMETROSCONFIGURA
	
	Lista os valores atuais das variveis registradas no ms_configura
	
	Retorno:
	
	{JSON}
	*/
	case "PEGAPARAMETROSCONFIGURA":
		$vs = array(
			"ows_abstract",
			"ows_keywordlist",
			"ows_fees",
			"ows_accessconstraints",
			"ows_contactperson",
			"ows_contactorganization",
			"ows_contactposition",
			"ows_addresstype",
			"ows_address",
			"ows_city",
			"ows_stateorprovince",
			"ows_postcode",
			"ows_country",
			"ows_contactelectronicmailaddress",
			"ows_name"			
		);
		$par = array();
		foreach ($vs as $v)
		{
			$par[$v] = utf8_encode($web->metadata->get($v));
		}
		retornaJSON($par);
		exit;
	break;
	/*
	Valor: SALVACONFIGURA
	
	Salva um novo valor de uma varivel no ms_configura.php

	Parameters:

	variavel - nome da varivel

	valor - novo valor
	
	Retorno:
	
	{JSON}
	*/
	case "SALVACONFIGURA":
		$web->metadata->set($variavel,$valor);
		$mapa->save($map_file);
		retornaJSON("ok");
	exit;
	break;
}

?>