<?php
/*
Title: Variveis de inicializao ms_configura.php

Nesse programa PHP so definidas as variveis globais principais necessrias ao funcionamento do I3Geo do lado do servidor web.

O ms_configura  includo em vrios programas do i3Geo e os valores das variveis devem ser editados 
caso a instalao do i3geo tenha sido feita em um diretrio diferente do padro.
No windows o diretrio padro  c:\ms4w\apache\htdocs\i3geo e no linux  /opt/www/html/i3geo

Para verificar a instalao do i3geo utilize o programa i3geo/testainstal.php, que pode fornecer algumas dicas
caso estejam ocorrendo problemas na iniciallizao.

As variveis de configurao so definidas em blocos diferentes conforme o sistema operacional (linux ou windows).

O ms_criamapa.php carrega o ms_configura.php e armazena a maior parte das variveis na seo. Algumas variveis
so tambm fornecidas para o cliente (navegador) na inicializao do mapa e ficam disponveis em variveis javascript.


Licenca:

GPL2

i3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Ministrio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@mma.gov.br

Este programa  software livre; voc pode redistribu-lo
e/ou modific-lo sob os termos da Licena Pblica Geral
GNU conforme publicada pela Free Software Foundation;

Este programa  distribudo na expectativa de que seja til,
porm, SEM NENHUMA GARANTIA; nem mesmo a garantia implcita
de COMERCIABILIDADE OU ADEQUAO A UMA FINALIDADE ESPECFICA.
Consulte a Licena Pblica Geral do GNU para mais detalhes.
Voc deve ter recebido uma cpia da Licena Pblica Geral do
GNU junto com este programa; se no, escreva para a
Free Software Foundation, Inc., no endereo
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

Arquivo: ms_configura.php

*/
/*
	Variavel: linkedinoauth (ainda no implementado)
	
	Parmetros registrados no Linkedin para permitir que o i3Geo faa autenticao com base na conta do usurio
	
	O Linkedin exige que cada site seja registrado para permitir que a API de autenticao funcione
	
	Veja o site para maiores informaes: http://developer.linkedin.com/docs/DOC-1008

	Caso vc no queira permitir essa opo, deixe essa varivel vazia, e.x
		
	Ao registrar utilize o valor http://meuservidor/i3geo/pacotes/openid/login.php?login

	Exemplo:
	
	$linkedinoauth = array(
		"consumerkey" => "0oQ30ge-ggKarx4HGaXVK118n8mekMBbFYTrC-agGV9hvxUXfeWwS1q7ZMvD-8LL",
		"consumersecret" => "nRGXfHp1XNMt0eCG7tWJpoCcXX1uoZseDtgiU-CRy1ajqipo4KpjjZdDUXmqZGQA"
	);	
	
	Tipo:
	{array}
*/
$linkedinoauth = "";
/*
	Variavel: facebookoauth
	
	Parmetros registrados no Facebook para permitir que o i3Geo faa autenticao com base na conta do usurio
	
	O Facebook exige que cada site seja registrado para permitir que a API de autenticao funcione
	
	Veja o site para maiores informaes: http://developers.facebook.com/setup/

	Caso vc no queira permitir essa opo, deixe essa varivel vazia, e.x
		
	Ao registrar utilize o valor http://meuservidor/i3geo/pacotes/openid/login.php?login

	Exemplo:
	
	$facebookoauth = array(
		"consumerkey" => "136279263094148",
		"consumersecret" => "679fc4a007b1d289377fa8af8f7086b6"
	);	
	
	Tipo:
	{array}
*/
$facebookoauth = array(
	"consumerkey" => "136279263094148",
	"consumersecret" => "679fc4a007b1d289377fa8af8f7086b6"
);
/*
	Variavel: twitteroauth
	
	Parmetros registrados no Twitter para permitir que o i3Geo faa autenticao com base na conta do usurio
	
	O Twitter exige que cada site seja registrado para permitir que a API de autenticao funcione
	
	Veja o site para maiores informaes: http://www.snipe.net/2009/07/writing-your-first-twitter-application-with-oauth/

	Lista de aplicaes cadastradas: https://twitter.com/oauth_clients/

	Caso vc no queira permitir essa opo, deixe essa varivel vazia, e.x
	
	$twitteroauth = "";
	
	Ao registrar a aplicao, utilize o endereo do i3geo em Application Website, por exemplo http://meuservidor/i3geo
	
	Ao registrar utilize como "Callback URL" o valor http://meuservidor/i3geo/pacotes/openid/login.php?login

	Exemplo:
	
	$twitteroauth = array(
		"consumerkey" => "vUvBcsOULjS0ewxuSvbS6w",
		"consumersecret" => "0Hj6uCyycDCeNOgzTUF1bBSel75KtfbnCS4bxWVqaxk",
		"requesttokenurl" => "https://twitter.com/oauth/request_token",
		"accesstokenurl" => "https://twitter.com/oauth/access_token",
		"authorizeurl" => "https://twitter.com/oauth/authorize"
	);	
	
	Tipo:
	{array}
*/
$twitteroauth = array(
	"consumerkey" => "vUvBcsOULjS0ewxuSvbS6w",
	"consumersecret" => "0Hj6uCyycDCeNOgzTUF1bBSel75KtfbnCS4bxWVqaxk",
	"requesttokenurl" => "https://twitter.com/oauth/request_token",
	"accesstokenurl" => "https://twitter.com/oauth/access_token",
	"authorizeurl" => "https://twitter.com/oauth/authorize"
);	
/*
	Variavel: mensagemInicia
	
	Mensagem de inicializao mostrada pelo programa ms_criamapa.php
	
	 obtida de um include para permitir a atualizao da verso nos pacotes de correo
	
	Tipo:
	{string}
*/
if(file_exists("versao.php"))
{include_once("versao.php");}
else
{$mensagemInicia = "";}
/*
	Variable: tituloInstituicao
	
	Nome que ser utilizado em alguns cabealhos e ttulos de pginas
	
	Tipo:
	{string}
*/
$tituloInstituicao = "i3Geo";
/*
	Variable: emailInstituicao
	
	Endereo de e-mail que pode ser mostrado na interface do mapa
	
	Tipo:
	{string}
*/
$emailInstituicao = "geoprocessamento@mma.gov.br";
/*
	Variable: googleApiKey
	
	Chave utilizada pela API do Google maps.
	
	A API do Google maps  utilizada em algumas funcionalidades do i3geo. Vc deve registrar uma chave
	no site do Google para o seu endereo de servidor web. veja como fazer em:
	http://code.google.com/apis/maps/signup.html
	
	Tipo:
	{string}
*/
$googleApiKey = "ABQIAAAAKguAlmd-hSDulF2T_tfWMxT3OAK09d_ZSDyC36iPGlww-4j-9xSrR2ZZUxVeZC01q8anfe5ntl_U4w";

if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN'))
{
	/*
	Variable: navegadoresLocais
	
	Ip dos usuarios que podem navegar no servidor para acessar arquivos de dados geogrficos.
	
	O i3geo possibilita que os usurios acessem dados geogrficos no servidor diretamente, navegando pelo sistema de arquivos.
	Isso possibilita o acesso aos dados mesmo que no constem na rvore de temas definida em menutemas/menutemas.xml
	Por segurana, essa funcionalidade s  ativada para nmeros IP especficos, definidos nessa varivel.
	
	Para cada IP registrado, deve-se definir os diretrios que sero acessveis, conforme mostrado abaixo.
	
	A validao do IP  feita com javascript, na inicializao do mapa, a varivel javascript objmapa.navegacaoDir  definida como sim (caso $navegadoresLocais for diferente de "") ou nao.
	
	Se objmapa.navegacaoDir for igual a "sim", ou seja, $navegadoresLocais  diferente de "", na guia de adio de temas da interface HTML, ser mostrada a opo de navegao. Portanto, se vc no quiser que essa opo seja ativada, mantenha essa varivel igual a
	
	$navegadoresLocais = "";
	
	Com a opo ativa na interface do mapa, o ip do cliente  verificado e caso estiver registrado no array, a navegao pelos diretrios do servidor ser permitida. Para mais detalhes, veja a ferramenta i3geo/ferramentas/navegacaodir
	 
	Tipo:
	{array}
	*/
	$navegadoresLocais = array(
							array(
							"ip"=>"127.0.0.1",
							"drives"=>array(
										array("caminho"=>"c:/","nome"=>"c"),
										array("caminho"=>"d:/","nome"=>"d")
										)
							)
						);
	/*
	Variable: editores
	
	Ip dos usuarios que podem administrar o i3geo via navegador.
	
	Separe os ips por vrgula. Os usurios que tiverem seus ips listados, podero editar o diretrio i3geo/temas, desde que os mesmos tenham direito de leitura e escrita nesse diretrio.
	
	Tipo:
	{array}
	*/
	$editores = array("127.0.0.1","localhost");
	/*
	Variable: dir_tmp
	
	Caminho completo do diretrio temporrio utilizado pelo mapserver.
	
	Tipo:
	{string}
	*/
	$dir_tmp = "c:/ms4w/tmp/ms_tmp";
	/*
	Variable: locaplic
	
	Caminho completo onde fica o I3Geo
	
	Tipo:
	{string}
	*/
	$locaplic = "c:/ms4w/apache/htdocs/i3geo";
	/*
	Variable: locmapserv
	
	Localizao do executvel do Mapserver conforme deve ser acrescentado a URL aps o nome do host.
	
	Essa varivel  necessria em processos que utilizam o mapserver no modo CGI.
	
	Por exemplo, se o endereo for http://localhost/cgi-bin/mapserv.exe, a varivel dever conter apenas /cgi-bin/mapserv.exe
	
	Tipo:
	{string}
	*/
	$locmapserv = "/cgi-bin/mapserv.exe";
	/*
	Variable: locmapas 
	
	Onde fica o xml, para preencher a guia mapas.
	
	Se for "" ser utilizado o sistema de administrao do i3geo (veja i3geo/admin).	
	
	A guia "Mapas" mostra uma lista de links que permitem abrir mapas especficos. Essa lista  utilizada tambm pela verso mobile do i3geo.
	
	Veja a documentao especfica do arquivo mapas.xml para maiores detalhes.
	
	Tipo:
	{string}
	*/
	$locmapas = "";
	/*
	Variable: R_path
	
	Onde esta o executavel do software R
	
	O R  um pacote estatstico utilizado pelo I3Geo para gerao de grficos e anlises estatsticas
	Se vc no possui o R instalado, comente a linha abaixo
	
	Tipo:
	{string}
	*/
	$R_path = "c:/r/win/bin/R.exe";
	/*
	Variable: postgis_mapa
	
	String de conexo para acesso aos dados (opcional).
	
	Prefira usar o esquema de criptografia nativo do Mapserver, veja em:
	
	http://mapserver.org/utilities/msencrypt.html
	
	Com o uso opcional dessa varivel  possvel esconder a string de conexo com o banco de dados. O Mapserver
	no permite esconder essa string, por isso, no i3geo, foi implementado um esquema de substituio.
	Toda vez que um objeto "map"  criado via PHP Mapscript, a string de conexo  substituda de " " para o valor de $postgis_mapa.
	Se no for desejado a substituio, deixe essa varivel em branco.
	Se vc especificar essa varivel, o mapa ser forado a recusar o modo de operao CGI.
	
	Para mais detalhes veja a funo substituiCon em classesphp/funcoes_gerais.php
	
	Importante - se vc usar o modo de substituio de strings, as interfaces que dependem do modo CGI
	para funcionarem, no sero capazes de acessar os dados. Isso afeta por exemplo, a interface Google Maps e Openlayers.
	
	exemplo - 
	
	$postgis_mapa = array(
		"conexao1"=>"user=geodados password=geodados dbname=geodados host=10.1.1.36 port=5432",
		"conexao2"=>"user=geodados password=geodados dbname=geodadosteste host=10.1.1.36 port=5432"
	)
	
	Tipo:
	{array ou  string}
	*/
	$postgis_mapa = array(
		"teste"=>"user=postgres password=postgres dbname=postgis host=localhost port=5432 options='-c client_encoding=LATIN1'",
		"postgres"=>"user=postgres password=postgres dbname=postgis host=localhost port=5432'",
	); //"user=geodados password=geodados dbname=geodados host=10.1.1.36 port=5432";
	/*
	Variable: utilizacgi
	
	Varivel indicando se o desenho do corpo do mapa ser baseado no modo cgi.
	
	Por default, o mapserver desenha o mapa via php, porm, pode-se alterar o modo de desenho.
	
	No modo normal, a imagem do mapa  gerada e armazenada no diretrio ms_tmp. Aps a gerao da imagem 
	o endereo do arquivo  retornado ao mapa (retorno via Ajax) e o javascript se encarrega de alterar o
	endereo da imagem no navegador. Com o uso do CGI a imagem no  gerada, sendo repassado ao navegador
	o endereo do cgi acrescentado do nome do mapfile, fazendo com que a imagem seja retornada diretamente.
	
	Em alguns casos o uso do cgi torna a aplicao mais rpida.
	
	Tipo:
	{string}
	*/
	$utilizacgi = "nao";
	/*
	 Variable: expoeMapfile
	 
	 Essa varivel controla se o nome do mapfile atual ser ou no retornado para a aplicao via ajax.
	 
	 Quando essa varivel for definida como "nao" algumas das funcionalidades do i3geo podero ficar prejudicadas, mas sem comprometimento das funes principais.
	 
	 Tipo:
	 {string}
	*/
	$expoeMapfile = "sim";
	/*
	 Variable: conexaoadmin
	 
	 Arquivo PHP que define a string de conexo (PDO) com o banco de dados administrativo.
	 
	 Esse arquivo  includo no programa i3geo/admin/conexao.php
	 
	 O banco de dados administrativo  utilizado para definir coisas como a rvore de temas, rvore de mapas, etc.
	 
	 O banco de dados, originalmente,  montado em SQLITE, porm, em ambientes corporativos, sugere-se o uso de bancos de daods mais robustos.
	 
	 Se voc quiser utilizar a conexo default, baseado no SQLITE, mantenha essa varivel vazia.
	 
	 O uso do banco de dados no  obrigatrio, uma vez que os arquivos podem ser mantidos em disco (arquivos XML).
	
	 O programa PHP que estabelece a conexo deve retornar objetos com nomes padronizados. Veja o arquivo i3geo/admin/conexao.php para maiores detalhes.
	
	 Exemplos:
	 
	 $conexaoadmin = $locaplic."/admin/php/conexaopostgresql.php";
	 $conexaoadmin = $locaplic."/admin/php/conexaomma.php";
	
	Tipo:
	{string}
	*/
	$conexaoadmin = "";
	/*
	 Variable: interfacePadrao
	 
	 Interface padro utilizada para abrir o mapa.
	 
	 A interface pode ser um arquivo com as extenses .htm .html .phtml
	 
	 O arquivo deve estar armazenado em i3geo/aplicmap
	 
	 A interface padro  utilizada quando no  definida nenhuma interface via URL.
	 
	 Tipo:
	 {string}
	*/
	$interfacePadrao = "openlayers.htm";
}
else //se for linux
{
	//verifica se est sendo utilizado o diretrio "opt" ou "var"
	if(file_exists("/opt/www/html/i3geo/ms_criamapa.php")){
		$dir_tmp = "/var/tmp/ms_tmp";
		$locaplic = "/opt/www/html/i3geo";	
	}
	else{
		$dir_tmp = "/tmp/ms_tmp";
		$locaplic = "/var/www/i3geo";
		$base = "geral1debian";
		$estadosl = "estadosldebian";
	}
	$editores = array("127.0.0.1","localhost");
	$navegadoresLocais = "";
	$locmapserv = "/cgi-bin/mapserv";
	$R_path = "R";//se vc no instalou o R no seu servidor, tente o endereo $R_path = $locaplic."/pacotes/r/linux/r";
	$postgis_mapa = "";
	$utilizacgi = "nao";
	$expoeMapfile = "sim";
	$conexaoadmin = "";
	$interfacePadrao = "openlayers.htm";
}
?>
